--Foreign key violations example
CREATE TABLE parent (
parent_id int NOT NULL,
PRIMARY KEY(parent_id)
) ENGINE=InnoDB;

CREATE TABLE child (
parent_id int NOT NULL,
KEY parent_id (parent_id),
CONSTRAINT child_ibfk_1 FOREIGN KEY (parent_id) REFERENCES parent (parent_id)
) ENGINE=InnoDB;

INSERT INTO parent(parent_id) VALUES(1);
INSERT INTO child(parent_id) VALUES(1);

DELETE FROM parent;

ALTER TABLE parent MODIFY parent_id INT UNSIGNED NOT NULL;


--Deadlock example
create table innodb_deadlock_maker(a int primary key) engine=innodb;

-- Connection 0
start transaction;
insert into innodb_deadlock_maker values(1);

-- Connection 1
start transaction;
select * from innodb_deadlock_maker for update;

-- Connection 0
insert into innodb_deadlock_maker values(0);


